//Parametros para la tuerca
rad_ext=22/2+0.5;
rad_int=20/2+0.5;		
rad_rosca=9.5/2;		//no importa demasiado para el diseño. Es M10.

alt_ext=16.5;
alt_total=20+1.5;
alt_rebaje=(alt_total-alt_ext)/2;

//Parametros para el soporte
grosor=2+0.5;
alt_soporte=alt_rebaje+2;

$fn=100;

module tuerca_husillo(){

	difference(){
		union(){
			translate([0,0,alt_ext/2])
				rebaje();
			cylinder(r=rad_ext,h=alt_ext,center=true);
			rotate([0,180,0])
				translate([0,0,alt_ext/2])
					rebaje();
			}
		cylinder(r=rad_rosca,h=alt_total*2,center=true);
	}
}

module rebaje(){
	translate([0,0,-0.1])
		cylinder(r1=rad_ext,r2=rad_int,h=alt_rebaje+0.1);
}

module base_soporte(){
	difference(){
		cylinder(r=rad_ext+grosor,h=alt_total+alt_soporte,center=true);
//		cylinder(r=rad_ext+grosor+1,
//						h=(alt_total-alt_soporte*2),
//						center=true);
		cylinder(r=rad_rosca+1,h=alt_total*2,center=true);
	}

}

module soporte(){
	ajuste=15;
	tamanio=rad_ext+grosor+ajuste;
	difference(){
		base_soporte();
		tuerca_husillo();
//		rotate([0,0,-90])
//			translate([ajuste/-1.2,ajuste/-1.2,(alt_total-grosor+2)/-2])
//				cube([tamanio,tamanio,alt_total-grosor+2]);
			translate([ajuste/2,ajuste/-2,(alt_total-grosor+2.5)/-2])
				cylinder(r=tamanio/2,h=alt_total-grosor+2.5);

	}
	sop_imp();
}

module sop_imp(){
	altura=23;
	difference(){
		rotate([0,0,-45])
		translate([0,0,(alt_total/-2)-1])
		union(){
			translate([-7,-7,0])
				cube([0.5,14,altura]);
			translate([-3,-9,0])
				cube([0.5,18,altura]);
			translate([2,-10,0])
				cube([0.5,20,altura]);
			translate([6,-12,0])
				cube([0.5,24,altura]);
			translate([9,-10,0])
				cube([0.5,20,altura]);
			translate([12,-6,0])
				cube([0.5,12,altura]);
		}
		translate([0,0,-1])
			cylinder(r=rad_rosca+1,h=alt_total+5,center=true);
	}
}


//tuerca_husillo();
//rebaje();
soporte();
//sop_imp();

